SystemOrganization addCategory: #'Lumiere-Examples'!

Object subclass: #LSuperbibleExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Examples'!

!LSuperbibleExamples commentStamp: 'FernandoOlivero 8/21/2009 08:06' prior: 0!
base := LShape cube.
	base scale: {20.0. 0.5. 20.0};texture: LTexture sand;color: Color yellow. 

	building := LShape cube.
	building scale: {2.0. 6.0. 2.0};material: LMaterial bronze.

	building2 := LShape cube.
	building2 scale: {5.0. 8.0. 5.0};material: LMaterial brass.

	city := LCompositeShape new.
	city
		addChild: base;
		addChild: building at: { -10.0. 0.5 + 6.0 . -5.0 };
		addChild: building2 at: { 5.0. 0.5 + 8.0. 0.0 }.



	parallel := LLight parallelLight.
	parallel
		ambient: {0.2. 0.2. 0.2. 1.0};
		diffuse: {0.25. 0.25. 0.25. 1.0};
		specular: {0.25. 0.25. 0.25. 1.0};
		location: {0.0. 0.0. 1.0}.
	spotlight := LLight spotlight. 
	spotlight
		ambient: {0.02. 0.02. 0.02. 1.0};
		diffuse: {0.3. 0.0. 0.0. 1.0};
		specular: {0.8. 0.0. 0.0. 1.0};
		angle: 180.0;
		location: {0.0. 0.0. 1.0}.	
			
	stage := LStage new.
	morph := stage asMorph.
	morph
		openInWorld;
		turnOnLights;
		addLight: directional ;
		addLight: spotlight ;
		addKeyboardNavigation;
		beGroundMovement;
		placeCameraAt: {0.0. 2.0. 10.0};
		viewingVolumeWithAngle: 45.0 aspect:1.0  zNear:1.0  zFar:200.0;
		scene: city asScene;
		position: 10@10;
		extent: 600@600.	
	

morph beFreeMovement.

morph addKeyboardInteraction. 

"6: Selection and picking: multiple selecion policy "
morph addClickingOnShapes.
morph beMultipleSelection.
morph removeClickingOnShapes.
morph delete!

!LSuperbibleExamples class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 9/2/2009 17:19'!
run: selector
	self new perform: selector ! !

!LSuperbibleExamples methodsFor: 'chapter10' stamp: 'FernandoOlivero 8/16/2009 20:23'!
openglWindow 
| bounds window  |
	bounds := 50 @ 50 extent: 500 @ 500.
	window := LOpenGLWindow newIn: bounds. 
	^ window ! !

!LSuperbibleExamples methodsFor: 'chapter12' stamp: 'FernandoOlivero 8/31/2009 10:56'!
planetsProgram
	"
	LSuperbibleExamples new planetsProgram.
	"
	|  scene stageMorph |
	scene := self planetsScene.
	stageMorph := 	scene asMicroworld asStage openAsMorph.
	stageMorph
		angle: 45.0 aspect: 1.0 zNear: 1.0 zFar: 500.0;
		addFloatingOverAwareness;
		addKeyboardNavigation;
		ambientLight:{0.9. 0.9. 0.2. 1.0};
		turnOnLights;
		placeCameraAt: {-80.0. 65.0. 130.0} lookingAt: {0.0. 0.0. 0.0};
		position: 600@40;
		update.
	
	! !

!LSuperbibleExamples methodsFor: 'chapter12' stamp: 'FernandoOlivero 8/25/2009 15:17'!
planetsScene
	| scene sun mercury venus earth mars solarSystem background |
	scene := LSceneGraph new.
	background := LShape quad.
	background
		color: Color darkGray;
		scale: {  150.0. 150.0  };
		texture: LTexture starsbackground.
	sun := LShape sphere.
	sun
		scale: 15.0;
		color: Color lightYellow;
		texture: LTexture sun.
	mercury := LShape sphere.
	mercury
		scale: 2.0;
		color: (Color 
				r: 0.5
				g: 0.0
				b: 0.0);
		texture: LTexture mercury.
	venus := LShape sphere.
	venus
		scale: 4.0;
		color: (Color 
				r: 0.5
				g: 0.5
				b: 1.0);
		texture: LTexture venus.
	earth := LShape sphere.
	earth
		scale: 8.0;
		color: Color lightBlue;
		texture: LTexture earth.
	mars := LShape sphere.
	mars
		scale: 4.0;
		color: (Color 
				r: 1.0
				g: 0.0
				b: 0.0);
		texture: LTexture mars.
	solarSystem := LCompositeShape new.
	solarSystem
		addChild: background
			at: {  0.0. 0.0. -15.0  };
		addChild: sun
			at: {  -50.0. 30.0. 0.0  };
		addChild: mercury
			at: {  (-50 + 4.0). 50.0. 0.0  };
		addChild: venus
			at: {  (-50 + 20.0). 30.0. 0.0  };
		addChild: earth
			at: {  (-50 + 50.0). 0.0. 0.0  };
		addChild: mars
			at: {  (-50 + 70.0). 10.0. 0.0  }.
	scene rootNode: solarSystem asNode.
	^ scene! !

!LSuperbibleExamples methodsFor: 'chapter10' stamp: 'FernandoOlivero 8/20/2009 06:54'!
snowmanCompositeShape
	| bottom midSection head nose noseColor mainBody cylinder hatBottom hatTop hat composite eyeL eyeR |
	mainBody := LCompositeShape new.
	bottom := LShape sphere .
	bottom
		 color: Color white;
		 scale: 0.4.
	mainBody addChild: bottom.
	midSection := LShape sphere .
	midSection 
		 color: Color white;
		 scale: 0.3.
	mainBody addChild: midSection at: {0.0. 0.55. 0.0}.
	head := LShape sphere .
	head 
		 color: Color white;
		 scale: 0.24.
	mainBody addChild: head at: {0.0. 0.95. 0.0}.
	eyeL := LShape sphere.
	eyeL 
		 color: Color black;
		 scale: 0.02.
	eyeR  := LShape sphere .
	eyeR 
		 color: Color black;
		 scale: 0.02.
	mainBody
		addChild: eyeR at: {0.1. 0.95. 0.21};
		addChild: eyeL at: {-0.1. 0.95. 0.21}.
	noseColor := Color
				r: 1.0
				g: 0.3
				b: 0.3.
	nose := LShape cylinder.
	nose 
		 color: noseColor;
		 scale: {0.04. 0.0. 0.3}.
	mainBody addChild: nose at: {0.0. 0.83. 0.3}.
	cylinder := LShape cylinder.
	cylinder 
		 color: Color black;
		 scale: {0.17. 0.17. 0.4}.
	hatBottom := LShape donut.
	hatBottom 
		 color: Color black;
		 scale: {0.17. 0.28}.
	hatTop := LShape disk.
	hatTop 
		 color: Color black;
		 scale:  0.17.
	hat := LCompositeShape new.
	hat
		addChild: cylinder;
		addChild: hatBottom at: {0.0. 0.0. -0.2 } rotatedBy: {180.0. 0.0. 1.0. 0.0};
		addChild: hatTop at: { 0.0. 0.0. 0.2 } rotatedBy: {180.0. 0.0. 1.0. 0.0}.
	composite := LCompositeShape new.
	composite
		scale: {5.0. 5.0. 5.0};
		addChild: mainBody;
		addChild: hat at: {0.0. 1.32. 0.0 } rotatedBy: {-90.0. 1.0. 0.0. 0.0};
		scale: {5.0. 5.0. 5.0}.
	^ composite! !

!LSuperbibleExamples methodsFor: 'chapter10' stamp: 'FernandoOlivero 8/31/2009 10:50'!
snowmanProgram
	| blue light0 scene snowbackground morph |
	"
	 LSuperbibleExamples new snowmanProgram.
	"
	light0 := LDirectionalLight new.
	light0
		ambient: { 0.25. 0.25. 0.25. 1.0};
		diffuse: { 0.25. 0.25. 0.25. 1.0};
		specular: { 0.15. 0.15. 0.15. 1.0};
		location: {-10.0. 5.0. 5.0. }.
		
	blue := Color r:0.25 g: 0.25 b:0.50. 
	
	snowbackground := LShape cube .
	snowbackground
		color: Color white;
		texture: LTexture snowbackground;
		scale: {10.0. 5.0. 0.1}.
	scene := LCompositeShape new.
	scene
		addChild: snowbackground;
		addChild: self snowmanCompositeShape at:{0.0. -2.5. 2.0} rotatedBy: {20.0. 0.0. 1.0. 0.0}.
	morph := scene openAsMorph.
	morph
		addLight: light0 ;
		ambientLight: { 0.05. 0.05. 0.05. 1.0 };
		backgroundColor: blue;
		placeCameraAt: {0.0058. -2.38. 9.45} lookingAt: {0.11. -2.16. 8.48};
		viewingVolumeWithAngle: 45.0 aspect: 1.0 zNear:1.0 zFar: 20.0;
		addKeyboardNavigation;
		beFreeMovement.
		morph explore.! !

Object subclass: #LumiereExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Examples'!

!LumiereExamples commentStamp: 'FernandoOlivero 8/21/2009 08:06' prior: 0!
"Raw OGL interface"
GLOpenGLLibraryExamples run:#testGeneratingAndDrawingVertexArrayCube.

"2: Shape abstracions"
"3: Composite shapes"
LSceneExamples new testRenderingAllPrimitives.

"8. nice examples"
LSuperbibleExamples new snowmanProgram.
LSuperbibleExamples new planetsProgram.

"4: Layout and performance"
LSceneExamples new testFrustumCullingPerformance. 

"5: Morphic integration: highlight and selection via mouse keyboard" 
LSceneExamples  new testRenderingPickingScene.


"--------------------------------------------------->"

"6: Keyboard navigation"
stageMorph := LSceneExamples new testGroundMovement.

stageMorph beFreeMovement.

stageMorph addKeyboardInteraction. 

"6: Selection and picking: multiple selecion policy "
stageMorph addClickingOnShapes.
stageMorph beMultipleSelection.
stageMorph removeClickingOnShapes.
stageMorph delete
"----------------------------------------------------------"

"7. morphs integration as billboards"
LSceneExamples new testMorphicBillboardTextures.

" backstage?"
LSceneExamples new testBackstage.


gw := GauchoWorkspace 	uniqueInstance.
gw openOnRecentSubmissions.
gw open.
gw close.
GauchoWorkspace forgetUniqueInstance.



B3DRenderingContextPlugin uniqueInstance deleteAllRenderers.!

!LumiereExamples class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 9/7/2009 07:31'!
debug: sel
	self new halt perform: sel.! !

!LumiereExamples class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 9/2/2009 19:14'!
run: sel
	self new perform: sel.! !

!LumiereExamples methodsFor: 'picking' stamp: 'FernandoOlivero 9/6/2009 21:16'!
testGridPickingScene
	"
	self  new testGridPickingScene
	"
	|  composite  colors stageMorph shape vl |
	composite := OrderedCollection  new.

	colors := {Color yellow. Color red. Color blue. Color green. Color cyan}.
	(1 to: 3 ) do:[:i|
		|scaledShape color|
		scaledShape := LShape cube .
		color := colors at:i.
		scaledShape scale:{2.0. 1.0. 1.0};model: color; color: color.
		composite add: scaledShape ].
	shape := LShape sphere .
	shape scale:2.0;color: Color brown. 
	composite add: shape.

	vl := LVerticalGridLayout new.
	vl
		gap:1.0;
		shapes: composite;
		run.
	
	stageMorph := vl openInWindow.
	stageMorph
		addFloatingOverAwareness;
		addClickingOnShapes;
		addKeyboardNavigation ;
		placeCameraAt: {8.0. 0.0. 25.0} lookingAt: {10.0. 0.0. 0.0}.
			
	stageMorph announcer on:LStageShapeHighlight do:[:ann|
			ann shape notNil ifTrue:[
				Transcript show: ann shape color;cr.]].
	Transcript open.
! !

!LumiereExamples methodsFor: 'navigation' stamp: 'FernandoOlivero 9/6/2009 21:16'!
testGroundMovement
	| morph base building building2 city directional spotlight |
	"
	self run:#testGroundMovement
	"
	base := LShape cube.
	base scale: {20.0. 0.5. 20.0};texture: LTexture sand;color: Color yellow. 
	building := LShape cube.
	building scale: {2.0. 6.0. 2.0};material: LMaterial bronze;texture: LTexture pharoIcon.
	building2 := LShape cube.
	building2 scale: {5.0. 8.0. 5.0};material: LMaterial brass;texture: LTexture esug.
	city := LCompositeShape new.
	city
		addChild: base;
		addChild: building at: { -10.0. 0.5 + 6.0 . -5.0 };
		addChild: building2 at: { 5.0. 0.5 + 8.0. 0.0 }.
	directional := LLight parallelLight.
	directional
		ambient: {0.2. 0.2. 0.2. 1.0};
		diffuse: {0.25. 0.25. 0.25. 1.0};
		specular: {0.25. 0.25. 0.25. 1.0};
		location: {0.0. 0.0. 1.0}.
	spotlight := LLight spotlight. 
	spotlight
		ambient: {0.02. 0.02. 0.02. 1.0};
		diffuse: {0.3. 0.0. 0.0. 1.0};
		specular: {0.8. 0.0. 0.0. 1.0};
		angle: 180.0;
		location: {0.0. 0.0. 1.0}.	
	morph := city openAsMorph.
	morph
		turnOnLights;
		addLight: directional ;
		addLight: spotlight ;
		addKeyboardNavigation;
		beGroundMovement;
		placeCameraAt: {0.0. 2.0. 10.0};
		viewingVolumeWithAngle: 45.0 aspect:1.0  zNear:1.0  zFar:200.0.
	^ morph! !

!LumiereExamples methodsFor: 'textures' stamp: 'FernandoOlivero 9/6/2009 15:15'!
testMaterials
	"
self new testMaterials 
"
	| pyramidGold pyramidSilver cubeJade cubeRubber base city spheres column morph |
	pyramidGold := LShape pyramid.
	pyramidGold
		scale: {  3.0. 3.0. 3.0  };
		material: LMaterial gold.
	pyramidSilver := LShape pyramid.
	pyramidSilver
		scale: {  4.0. 4.0. 4.0  };
		material: LMaterial silver.
	cubeJade := LShape cube.
	cubeJade
		scale: {  2.0. 2.0. 2.0  };
		material: LMaterial jade.
	cubeRubber := LShape cube.
	cubeRubber
		scale: {  4.0. 4.0. 2.0  };
		material: LMaterial blackRubber.
	spheres := OrderedCollection new.
	10 timesRepeat: 
		[ | shpe |
		shpe := LShape sphere.
		shpe color: Color random.
		spheres add: shpe ].
	column := LCenteredFlowLayout new.
	column
		beVertical;
		shapes: spheres;
		gap: 1.0;
		run.
	base := LShape cube.
	base
		scale: {  20.0. 0.5. 20.0  };
		texture: LTexture sand;
		color: Color yellow.
	city := LCompositeShape new.
	city
		addChild: base;
		addChild: pyramidGold
			at: {  -10.0. 3.5. -5.0  };
		addChild: pyramidSilver
			at: {  10.0. 2.5. 0.0  };
		addChild: cubeJade
			at: {  0.0. 2.5. 2.0  };
		addChild: cubeRubber
			at: {  5.0. 4.5. -10.0  };
		addChild: column
			at: {  10.0. 2.0. -5.0  }.
	
	morph := city openAsMorph. 
	morph
		ambientLight: {  0.05. 0.05. 0.05. 1.0  };
		placeCameraAt: {  0.0. 2.0. 20.0  };
		addKeyboardNavigation.! !

!LumiereExamples methodsFor: 'textures' stamp: 'FernandoOlivero 9/6/2009 15:14'!
testMorphicBillboardTextures
"
self new testMorphicBillboardTextures
"

	| im morphicBillboard |
	im := ImageMorph authoringPrototype.
	im image: (Form fromDisplay: (0@0 extent: 1000@800 )).
	im openInWorld.
	
	morphicBillboard := LMorphicBillboard  new .
	morphicBillboard
		scale: {10.0. 10.0};
		morph: im. 
	
	"on construction!!"	! !

!LumiereExamples methodsFor: 'picking' stamp: 'FernandoOlivero 9/7/2009 07:19'!
testMorphicIntegration
	"
	self  new testMorphicIntegration
	"
	|  composite  colors stageMorph shape vl positions morph morphs hm |
	composite := OrderedCollection  new.
	morphs := OrderedCollection new.
	positions := {800@340. 1000@340. 800@180. 1000@180. 800@20. 1000@20}.
	colors := {Color brown. Color red. Color blue. Color green. Color gray}.
	(1 to: 5 ) do:[:i|
		|scaledShape color|
		scaledShape := LShape cube .
		color := colors at:i.
		scaledShape scale:{2.0. 1.0. 1.0};model: color; color: color.
		morph := BorderedMorph authoringPrototype.	
		morph
			borderWidth: 5.0;
			extent: 100@100;
			color: color;
			position: (positions at:i).
		morphs add: morph.	
		composite add: scaledShape ].
	shape := LShape sphere .
	shape scale:2.0;color: Color brown. 
	composite add: shape.
	morph := BorderedMorph authoringPrototype.	
	morph
			borderWidth: 5.0;
			extent: 100@100;
			color: Color brown ;
			position: (positions at:6).
	morphs add: morph.
	
	vl := LVerticalGridLayout new.
	vl
		gap:1.0;
		shapes: composite;
		run.
	
	stageMorph := vl openInWindow.
	stageMorph
		addFloatingOverAwareness;
		addClickingOnShapes;
		addKeyboardNavigation ;
		placeCameraAt: {8.0. 0.0. 25.0} lookingAt: {10.0. 0.0. 0.0}.
	
	morphs do:[:m| m openInWorld ].
	
	stageMorph announcer on:LStageShapeHighlight do:[:ann| ann shape notNil ifTrue:[ 
			morph := morphs detect:[:m| m color = ann shape color ] ifNone:nil.
			morph notNil ifTrue:[ 
				hm := morphs  select:[:m| m borderColor = Color white ].
				hm notEmpty ifTrue:[ hm first borderColor: Color black ].
				morph borderColor: Color white ] ] ].

	stageMorph announcer on:LStageShapeSelection do:[:ann| ann shape notNil ifTrue:[ 
			morph := morphs detect:[:m| m color = ann shape color ] ifNone:nil.
			morphs do:[:m| m borderWidth: 6 ;borderColor: Color black].
			morph notNil ifTrue:[ morph borderWidth: 10; borderColor: Color yellow ] ] ].	
! !

!LumiereExamples methodsFor: 'shapes' stamp: 'FernandoOlivero 9/7/2009 07:39'!
testRenderingAllPrimitives
	"
	self new testRenderingAllPrimitives
"
	| cube primitives sphere disk donut cappedCylinder pyramid base morph column wiredPyramid wiredSphere texPyramid |
	base := LShape cube.
	base
		color: Color brown;
		scale: {  14.0. 0.2. 4.0  }.
	cube := LShape cube.
	cube color: Color red.
	disk := LShape disk.
	disk color: Color cyan.
	donut := LShape donut.
	donut color: Color lightGreen.
	wiredPyramid := LShape pyramid.
	wiredPyramid
		color: Color yellow;
		fillMode: 'line'.
	column := LCenteredFlowLayout column.
	column
		shapes: {  cube. disk. donut  };
		gap: 0.25;
		run.
	sphere := LShape sphere.
	sphere
		color: Color blue;
		scale: 3.0.
	cappedCylinder := LShape cappedCylinder.
	cappedCylinder
		color: Color gray;
		scale: {  0.5. 0.5. 8.0  }.
	pyramid := LShape pyramid.
	pyramid
		color: Color orange;
		scale: {  2.0. 2.0. 2.0  }.
	wiredSphere := LShape sphere.
	wiredSphere
		color: Color blue;
		fillMode: 'line';
		scale: 1.5.
	texPyramid := LShape pyramid.
	texPyramid
		scale: {  2.0. 3.0. 2.0  };
		color: Color white.
	primitives := LCompositeShape new.
	primitives
		addChild: base;
		addChild: column
			at: {  0.0. 2.5. -4.0  };
		addChild: sphere
			at: {  -5.0. 3.5. 0.0  };
		addChild: cappedCylinder
			at: {  2.5. 1.0. 0.0  };
		addChild: pyramid
			at: {  8.0. 2.5. 0.0  };
		addChild: wiredSphere
			at: {  7.0. 6.0. 3.0  };
		addChild: texPyramid
			at: {  -12.0. 3.5. 0.0  }.
	morph := primitives openAsMorph.
	morph
		placeCameraAt: {  0.0. 4.0. 40.0  }
			lookingAt: {  0.0. 1.5. 0.0  };
		bounds: (400 @ 150 extent: 500 @ 500);
		turnOnLights;
		addDefaultLights;
		addKeyboardInteraction;
		addFloatingOverAwareness;
		addClickingOnShapes.
	^ morph! !

!LumiereExamples methodsFor: 'composite shapes' stamp: 'FernandoOlivero 9/6/2009 21:16'!
testRenderingChainedScaledCubesScene
	"
	self  new testRenderingChainedScaledCubesScene
	"
	| composite scaledShape scaledShape2 morph |
	composite := LChainedCompositeShape new..
	scaledShape := LShape cube.
	scaledShape scale:{10.0. 10.0. 10.0}.
	composite addChild: scaledShape.
	scaledShape2 := LShape cube.
	scaledShape2 scale:{10.0. 30.0. 10.0}.
	composite addChild: scaledShape2 translatedBy: {25.0. 0.0. 0.0}.
	morph := composite openAsMorph.
	morph
		placeCameraAt: {0.0. 0.0. 100.0} lookingAt:  { 0.0. 0.0. 0.0};
		turnOnLights;
		addDefaultLights;
		addKeyboardNavigation.! !

!LumiereExamples methodsFor: 'shapes' stamp: 'FernandoOlivero 9/7/2009 07:40'!
testRenderingCubeWithNormalsScene
	"
	self new testRenderingCubeWithNormalsScene
	"
	| material cube morph |
	material := LMaterial new. 
	material
		colorize: Color red;
		specular: {0.5. 0.5. 0.5. 1.0};
		shininess: 10.0.	
	cube := LShape pyramid .
	cube material: material.
	morph := cube openAsMorph.
	morph
		turnOnLights;
		addDefaultLights;
		placeCameraAt:{4.0. 0.0. 6.0} lookingAt:{ -2.0. 0.0. 0.0 };
		update.
	^ morph	! !

!LumiereExamples methodsFor: 'shapes' stamp: 'FernandoOlivero 9/7/2009 07:40'!
testRenderingCubeWithoutNormalsCubeScene
	"
	self new testRenderingCubeWithoutNormalsCubeScene
	"
	| cube morph |
	cube := LShape cube .
	cube color: Color blue.
	morph := cube openAsMorph.
	morph
		turnOffLights ;
		placeCameraAt:{0.0. 0.0. 10.0} lookingAt:{0.0. 0.0. 0.0};
		update.! !

!LumiereExamples methodsFor: 'layout' stamp: 'FernandoOlivero 9/6/2009 21:16'!
testRenderingFlowLayoutOfCompositeScene
	"
	self run:#testRenderingFlowLayoutOfCompositeScene
	"
	| flowLayout line morph |
	line := OrderedCollection new.
	10 timesRepeat: 
		[ | shape |
		shape := LShape cube.
		shape
			scale: {  2.0. 4.0. 2.0  };
			color: Color random.
		line add: shape ].
	10 timesRepeat: 
		[ | shape |
		shape := LShape sphere.
		shape
			scale: 2.0;
			color: Color random.
		line add: shape ].
	flowLayout := LCenteredFlowLayout new.
	flowLayout
		gap: 2.0;
		beHorizontal;
		shapes: line;
		run.
	morph := flowLayout openAsMorph.
	morph
		placeCameraAt: {190.0. 10.0. 140.0} lookingAt:  { 0.0. 0.0. 0.0};
		turnOnLights;
		addDefaultLights;
		addKeyboardNavigation.

! !

!LumiereExamples methodsFor: 'layout' stamp: 'FernandoOlivero 9/6/2009 21:16'!
testRenderingInDepthGridLayoutOfCompositeScene
	"
	self  new testRenderingInDepthGridLayoutOfCompositeScene
	"
	|   gridLayout grid morph |
	grid := OrderedCollection  new.
	2000  timesRepeat:[
		|shape|
		shape := LShape cube.
		shape scale:{2.0. 1.0. 2.0.}; color: Color random.
		grid add: shape ].
	gridLayout := LInDepthGridLayout new.
	gridLayout
		gap: 2.0;
		shapes: grid;
		run.
	morph := gridLayout openAsMorph.
	morph
		placeCameraAt: {0.0. 50.0. 50.0} lookingAt:  { 0.0. 10.0. -50.0};
		turnOnLights;
		addDefaultLights;
		addKeyboardNavigation.

! !

!LumiereExamples methodsFor: 'picking' stamp: 'FernandoOlivero 9/6/2009 21:16'!
testRenderingPickingScene
	"
	self  new testRenderingPickingScene
	"
	| composite x y z colors stageMorph compositeFront compositeGroup shape |
	composite := LCompositeShape new.
	x := y := z := 0.0.
	colors := { 
		(Color yellow).
		(Color red).
		(Color blue).
		(Color green).
		(Color cyan)
	 }.
	(1 to: 3) do: 
		[ :i | 
		| scaledShape color |
		scaledShape := LShape cube.
		color := colors at: i.
		scaledShape
			scale: {  2.0. 1.0. 1.0  };
			model: color;
			color: color.
		composite 
			addChild: scaledShape
			at: {  x. y. z  }.
		x := x + 6 ].
	shape := LShape sphere.
	shape
		scale: 2.0;
		color: Color brown.
	composite 
		addChild: shape
		at: {  x. y. z  }.
	compositeFront := LCompositeShape new.
	x := y := z := 0.0.
	colors := { 
		(Color yellow).
		(Color red).
		(Color blue).
		(Color green).
		(Color cyan)
	 } reverse.
	(1 to: 4) do: 
		[ :i | 
		| scaledShape color |
		scaledShape := LShape cube.
		color := colors at: i.
		scaledShape
			scale: {  2.0. 1.0. 1.0  };
			model: color;
			color: color.
		compositeFront 
			addChild: scaledShape
			at: {  x. y. z  }.
		x := x + 6 ].
	compositeGroup := LCompositeShape new.
	compositeGroup
		addChild: composite;
		addChild: compositeFront
			at: {  2.0. -1.3. 0.0  }.
	stageMorph := compositeGroup openAsMorph.
	stageMorph
		addFloatingOverAwareness;
		addClickingOnShapes;
		addKeyboardInteraction;
		placeCameraAt: {  8.0. 0.0. 25.0  }
			lookingAt: {  10.0. 0.0. 0.0  }.
	stageMorph announcer 
		on: LStageShapeHighlight
		do: 
			[ :ann | 
			ann shape notNil ifTrue: 
				[ Transcript
					show: ann shape color;
					cr ] ].
	Transcript open.
! !

!LumiereExamples methodsFor: 'layout' stamp: 'FernandoOlivero 9/6/2009 21:16'!
testRenderingPolarLayoutOfCompositeSceneInStageMorph
	"
	self  new testRenderingPolarLayoutOfCompositeSceneInStageMorph
	"
	|    shapes layout window |
	shapes := OrderedCollection new.
	7 timesRepeat:[
		|shape|
		shape := LShape sphere.
		shape color: Color random;scale: 1.0 .
		shapes add: shape ].
	 
	layout := LPolarLayout new.
	layout
		beCircle;
		radius:5.0;
		shapes: shapes;
		run.
	
	window := layout openInWindow.
	window 
		turnOnLights;
		addDefaultLights;	
		addClickingOnShapes;
		addFloatingOverAwareness.! !

!LumiereExamples methodsFor: 'layout' stamp: 'FernandoOlivero 9/7/2009 07:20'!
testRenderingVerticalGridLayoutOfCompositeScene
	"
	self  new testRenderingVerticalGridLayoutOfCompositeScene
	"
	|  gridLayout grid group morph |
	grid := OrderedCollection new.
	1000 timesRepeat: 
		[ | shape |
		shape := LShape cube.
		shape color: Color random.
		shape scale: {  1.0. 1.0. 1.0  }.
		grid add: shape ].
	gridLayout := LVerticalGridLayout new.
	gridLayout
		gap: 2.0;
		scale: {  2.0. 2.0. 2.0  };
		shapes: grid;
		run.
	group := LCompositeShape new.
	group
		addChild: gridLayout.
	morph := group openAsMorph .
	morph
		turnOnLights;
		addDefaultLights;
		addKeyboardNavigation;
		placeCameraAt: {gridLayout width /2.0 negated. gridLayout height /2.0. 150.0}
			lookingAt: {0.0. gridLayout height /2.0. 0.0}.! !

!LumiereExamples methodsFor: 'textures' stamp: 'FernandoOlivero 8/28/2009 12:07'!
testTextures
"
self new testTextures 
"
	
	| pyramid cube scene quad morph | 
	quad := LShape quad.  
	
	quad
		scale:{8.0. 4.0};
		color: Color white;
		texture: LTexture pharoSplash.
	
	pyramid := LShape pyramid .
	pyramid
		scale: {2.0. 3.0. 2.0};
		texture: LTexture sand.
	cube  := LShape cube.
	cube 
		scale: {2.0. 2.0. 2.0};
		texture: LTexture water.
	scene := LCompositeShape new.
	scene
		addChild: pyramid at: {-4.0. 0.0. 0.0 };
		addChild: cube at: { 4.0. 0.0. 0.0 };
		addChild: quad  at: { 0.0. 8.0. 0.0 }. 
	morph := scene openAsMorph.
	morph
		addFloatingOverAwareness;
		addClickingOnShapes.
	! !
